% setroot: find the root data directory and set 'dataroot'
% written by:  Jonathan Jacobs
%              February 1997 - April 1998  (last mod: 04/14/98)

% 21 March 2003: added '/' as sep character for MATLAB 6.5 (OS X, yay!)

function setroot()

global dataroot OMroot

curdir=pwd;

[comp, maxsize] = computer;
vers=version;
P = path;
if comp(1) == 'M' & vers(1)<='5' % 'classic' Mac OS
   sep  = ':';                   % between dirs in a single path
   sep2 = ';';                   % between path entries
 elseif comp(1) == 'P'           % PC
   sep  = '\'; 
   sep2 = ';';
 else                            % Unix (including Mac OS X)
   sep  = '/';
   sep2 = ':';    
end

% OMroot.txt and dataroot.txt live in omprefs dir
omprefpath = findomprefs;
if ~isempty(omprefpath)
	cd(omprefpath)
 else
   disp('Can not find omprefs folder.')
   return
end 

% find the root directories for the data files.
datarootfid = fopen( 'dataroot.txt', 'r' );
if datarootfid > 0
	dataroot = fread(datarootfid);
	dataroot = setstr(dataroot');
	dataroot=strtok(dataroot,[10 13]);
	if strcmp( dataroot(length(dataroot)),sep )
	   dataroot=dataroot(1:length(dataroot)-1);
	end
	fclose(datarootfid);
 else   
   fid=fopen('dataroot.txt','w');
   fwrite(fid, matlabroot, 'char');
   fclose(fid);
   dataroot = matlabroot;
   disp('<<<setroot.m>>>')
   disp('"dataroot.txt" missing from "MATLAB" directory.')
   disp('I have created a new copy, initialized to the')
   disp('"MATLAB" root directory.  Feel free to modify it.')
   disp(' ')
end

% go to the root directory for your data.
rootbad=0;
eval( ['cd ' '''' dataroot ''''],'rootbad=1;' )
if rootbad
   disp('  ')
   disp('<<<setroot.m>>>')
   disp('dataroot directory error found:')
   disp('The directory specified in "dataroot.txt" is invalid');
   disp('It must specify the root directory where your data resides.');
   disp('Check the file "dataroot.txt" in your root "MATLAB" directory');
   disp('and verify that the path specified there is correct.');
   disp('For the time being, I will set the root data')
   disp('directory to be your "MATLAB" root.')
   disp(' ')
   dataroot=matlabroot;   
end

try
	eval(['cd ' '''' curdir ''''])
 catch
   disp([curdir ' is not a valid directory.'])
end	