% findHotW.m: used by the editing functions to find
% the frontmost window that can be edited.

% Written by:  Jonathan Jacobs
%              March 1997 - January 1998  (last mod: 01/16/98)

function hotWind = findHotW;

temp=ver('MATLAB');
ML_VER = str2num(temp.Version);

windowList = get(0,'Children');
if isempty(windowList)
   disp('No windows open.')
   hotWind = -1;
   return
end

% set all non editing windows as fair game
% there is the possibility that we don't have a
% contiguous list of window numbers, so we must
% use 'eval' to check if each 'i' is valid
for i = 1:length(windowList)
   goodWindow = 1;
   eval('a=get(windowList(i),''Tag'');','goodWindow = 0;')
   if goodWindow
      temp = lower(get(windowList(i),'Tag'));
      %wTag = temp(5:length(temp));
      if isempty(findstr(temp,'editing'))...
              & isempty(findstr(temp,'zoomed'))...
              & isempty(findstr(temp,'mdlparam'))...
              & isempty(findstr(temp,'control'))...
              & isempty(findstr(temp,'uneditable'))...
              & isempty(findstr(temp,'nafxwindow'))...
         set(windowList(i),'Tag','hotWind');
      end
   end
end

% find the first editable window
for i = 1:length(windowList)
   if strcmp(get(windowList(i), 'Tag'),'hotWind')
       if ML_VER >= 8.4
          hotWind = get(windowList(i), 'Number');
       else
          hotWind = windowList(i);
       end
       
       return
   end
end

%disp('No hot window found')
hotWind = -1;
return
