% linebacker.m: Click on a line and send it to the back "layer" of the figure
% This is useful when you need to expose a line that is partially (or fully)
% hidden behind another one.  Click on the line that is in the way and then
% run "linebacker"

% Written by:  Jonathan Jacobs
%              June 2000  (last mod: 06/16/00)

function linebacker(null)

if ~strcmp(get(gco,'Type'),'line')
   disp('Double-click on a line before using this program')
   return
end

% find all the objects in the axis
ga = gca;
%ga = get(gco,'Parent');
children = get(ga,'children');

% Find the handle for the selected line
chillen = length(children);
linelist=[];
otherlist=[];
for i=1:chillen
   if strcmp(get(children(i),'Type'),'line')
      linelist=[linelist; i];
     else
      otherlist=[otherlist; i];
   end
   if gco==children(i)
      tgt = i;
   end
end

linlen  = length(linelist);

% have we clicked on the last line?
if tgt==linelist(linlen)
   % nothing to do, so we might as well...
   disp('already at the back.')
   return
end

% send the victim to the back
if length(linelist)==1
   disp('only one line was present.')
   return
 elseif length(linelist) == 2
   %disp('two lines present.')
   temp = [linelist(2); linelist(1)];
 else
   %disp([num2str(linlen) ' lines present.'])
   % have we clicked on the first line?
   if tgt == 1
      temp = [linelist(2:linlen); linelist(1)];
    else
      temp = [linelist(1:tgt-1); linelist(tgt+1:linlen); linelist(tgt)];
   end
end
final=[otherlist;temp];
set(ga,'Children',children(final));