% yankdata2.m:  Click on a data object and extract its x, y, or z data
% within the x-axis limits.
% Usage: out = yankdata2( whichdata );
% Where whichdata = 'x', 'y', 'z' or a combination (e.g. 'xy') .
% If no input argument is given, YANKDATA will prompt for input.
% EXAMPLE: To extract both x and y data -- [x,y]=yankdata('xy');

% Written by:  Jonathan Jacobs
%              June 1997 - May 2009 (last mod:  05/27/00)

function [out1, out2, out3] = yankdata2(which);

if isempty(gco)
   disp('You must click on a figure''s data object before running "YANKDATA."')
   return
end

if nargin == 0 & nargout == 0 
   help yankdata
   return
end

type = get(gco,'Type');

if strcmp(type, 'line') | strcmp(type, 'surface') | strcmp(type, 'patch')
   ;
 else
   disp('You must click on a line, surface or patch before running "YANKDATA."')
   return
end

if nargin == 0
   which = '';
   while( which~='x' & which~='y' & which~='z' )
      which = lower(input('Yank x, y or z data? ','s'));
   end
end

%which = lower(which);

% get xlims and translate to sample numbers
xlims=get(gca,'XLim');
xlow = xlims(1); xhigh=xlims(2);

temp = get(gco, 'xdata');

diff = abs(temp-xlow);
startpt = find( diff==min(diff) );
if isempty(startpt), startpt = 1; else startpt=startpt(1);end

diff = abs(temp-xhigh);
stoppt = find( diff==min(diff) );
if isempty(stoppt), stoppt = length(temp); else stoppt=stoppt(1);end

for j=1:length(which)
   eval(['temp = get(gco, ' '''' which(j) 'data'');'])
   eval(['out' num2str(j) ' = temp(startpt:stoppt)'';'])
end
