% fsacube.m: plot the foveal radius of +/- 0.5 degrees
% the slip radius of +/- 4 deg/sec,
% and an arbitrary acceleration (value can be changed)
% on top of an existing graph
% written by:  Jonathan Jacobs
%              April 1996 (last mod: 04/03/96)

% make sure there is reason to use fovrad
if isempty(get(gca, 'children'))
   disp( 'You need to have a 3-D phase plane plot to use "fsacube".' )
   close
   return
end

fov = 0.5; slip = 4; acc_rad = 500;

hold on
plot3( [-fov  fov], [ slip  slip], [ acc_rad  acc_rad], 'r-');
plot3( [-fov  fov], [ slip  slip], [-acc_rad -acc_rad], 'r-');
plot3( [-fov  fov], [-slip -slip], [ acc_rad  acc_rad], 'r-');
plot3( [-fov  fov], [-slip -slip], [-acc_rad -acc_rad], 'r-');

plot3( [ fov  fov], [-slip  slip], [ acc_rad  acc_rad], 'r-');
plot3( [ fov  fov], [-slip  slip], [-acc_rad -acc_rad], 'r-');
plot3( [-fov -fov], [-slip  slip], [ acc_rad  acc_rad], 'r-');
plot3( [-fov -fov], [-slip  slip], [-acc_rad -acc_rad], 'r-');

plot3( [ fov  fov], [ slip  slip], [-acc_rad  acc_rad], 'r-');
plot3( [ fov  fov], [-slip -slip], [-acc_rad  acc_rad], 'r-');
plot3( [-fov -fov], [ slip  slip], [-acc_rad  acc_rad], 'r-');
plot3( [-fov -fov], [-slip -slip], [-acc_rad  acc_rad], 'r-');
hold off

if ~exist('debugme') debugme = 0; end
if ~debugme
   clear fov slip acc_rad
end
