function plthv

global rh rv lh lv rt lt st sv namelist

plthFigH = figure;
plthFigColor = get(plthFigH,'color');
if plthFigColor(1) >= 0.6     %% Light background
   lhColor = 'g';
   rhColor = 'b';
 elseif plthFigColor(1) < 0.6;
   lhColor = 'y';
   rhColor = 'c';
end

%lvColor = [.7 .5 0];
lvColor = lhColor;
rvColor = rhColor;
ltColor = lhColor;
rtColor = rhColor;

if ~isempty(rt)
   t=maket(rt);
 elseif ~isempty(lt)
   t=maket(lt);
 else
   disp('No torsional data!?!')
   plthv
   return
end

maxpt=max(max([lh,rh,lv,rv,lt,rt]));
minpt=min(min([lh,rh,lv,rv,lt,rt]));
maxt=max(t);

figure
hold on
if ~isempty(lh)
   plot(t,lh,lhColor)
   lehH=text(maxt,maxpt-(maxpt-minpt)*.2,'LEH');
   set(lehH,'color', lhColor);
end   
if ~isempty(rh)
   plot(t,rh,rhColor)
   rehH=text(maxt,maxpt,'REH');
   set(rehH,'color', rhColor);
end   

if ~isempty(lv)
   plot(t,lv,'color',lvColor,'linestyle','--')
   levH=text(maxt,maxpt-(maxpt-minpt)*.6,'LEV');
   set(levH,'color', lvColor);
end   
if ~isempty(rv)
   plot(t,rv,'color',rvColor,'linestyle','--')
   revH=text(maxt,maxpt-(maxpt-minpt)*.4,'REV');
   set(revH,'color', rvColor);
end

if ~isempty(lt)
   plot(t,lt,'color',ltColor,'linestyle','-.')
   letH=text(maxt,minpt,'LET');
   set(letH,'color', ltColor);
end   
if ~isempty(rt)
   plot(t,rt,'color',rtColor,'linestyle','-.')
   retH=text(maxt,maxpt-(maxpt-minpt)*.8,'RET');
   set(retH,'color', rtColor);
end

if ~isempty(st)
   plot(t,st,'r')
   rehH=text(maxt,maxpt,'H. Stim');
   set(rehH,'color', 'r');
end   
if ~isempty(sv)
   plot(t,sv,'c')
   rehH=text(maxt,maxpt,'V. Stim');
   set(rehH,'color', 'r');
end   


if exist('namelist','var')
   if ~isempty(namelist)
      title(nameclean(namelist));
   end
end

ept;dragger

%clear rehH lehH revH levH retH letH
%clear tempFigH tempFigColor lhColor