% digstimplot.m: plot the digital stim information
%
% written by: Jonathan Jacobs
%             November 2001  (last mod: 11/08/01)
% modified by: L.F. Dell'Osso
%             November 2001  (last mod: 5/31/02)

% convert the timeline to seconds

hold on

aa = length(t_stim)*2-1;

xx(1:2:aa)   = t_stim/1000;
xx(2:2:aa-1) = t_stim(2:end)/1000;
yy(1:2:aa)   = whichLED;
yy(2:2:aa-1) = whichLED(1:end-1);

dp=plot(xx,LEDangles(yy),'md-');
set(dp, 'markerfacecolor','y')
set(dp, 'markeredgecolor','w')

drawrad(1.4,0,t(end)-5,t(end),'r',0);
drawrad(1.4,0,0,5,'r',0);
plot(t(1),1.4, 'r+',t(samp_freq*5),1.4,'r+')
plot(t(end-samp_freq*5),1.4,'r+',t(end),1.4,'r+')
maxconv=text(maxt,maxpt*.35,'NEAR');
far=text(maxt,minpt*0,'FAR');
set(maxconv,'color','m');
set(far,'color','r');

clear xx yy dp aa

% The following caused huge #'s of lines ID'ed by linedit:
%t05=sub(t,0,5);
%te5=sub(t,t(end-samp_freq*5),5);
%plot(t05,1.4,'r',te5,1.4,'r')
%      or
%plot(sub(t,0,5),1.4,'r',sub(t,t(end-samp_freq*5),5),1.4,'r')
