% grdcal.m: finish the calibration of gerdi's data.  necessary since it
% was taken with the old Robinson coil system.
% this should be run after EACH data file is loaded in, as it only modifies the
% last entry for each channel  (therefore it is important that the file being
% loaded has all four important channels i.e. RH LH RV LV)

% written by:  Jonathan Jacobs
%              April 1998  (last mod:  04/29/98)

day=-1;
while day<0 | day>2 
   day = input('Use adjustments for which day (1 or 2)? ');
end

[rhr,rhc]=size(rh);
[rvr,rvc]=size(rv);
[lhr,lhc]=size(lh);
[lvr,lvc]=size(lv);

%% day one's Offset and Scale factors
rho(1) = -1.00; rhs(1) = 3.03;
rvo(1) = -0.22; rvs(1) = 3.23;
lho(1) = +1.88; lhs(1) = 3.01;
lvo(1) = +0.30; lvs(1) = 2.90;

%% day two's Offset and Scale factors
rho(2) = -0.80; rhs(2) = 3.04;
rvo(2) = -0.40; rvs(2) = 3.23;
lho(2) = +0.00; lhs(2) = 3.00;
lvo(2) = +1.30; lvs(2) = 2.91;

if day == 0
   disp('No adjustments made.')
   return
end

%% the actual final adjustment is actually a bit of a letdown.
%% we are only performing these operations on the last data added
%% to the arrays.
rh(:,rhc) = asin( (rh(:,rhc)+rho(day))/(rhs(day)/0.2588) )*180/pi;
rv(:,rvc) = asin( (rv(:,rvc)+rvo(day))/(rvs(day)/0.2588) )*180/pi;
lh(:,lhc) = asin( (lh(:,lhc)+lho(day))/(lhs(day)/0.2588) )*180/pi;
lv(:,lvc) = asin( (lv(:,lvc)+lvo(day))/(lvs(day)/0.2588) )*180/pi;
