% pickdata.m:  pick which data you want to use.
% will work for both binary and ASCII format data, even
% when they have been mixed together in the files list.
% Creates: which_xx_col, to keep track of what
% data is in what position in the columns.
% PICKDATA can handle up to 30 files.
% written by:  Jonathan Jacobs
%              October 1995 - May 1998  (last mod: 05/01/98)

lh_count = 0; lv_count = 0; lt_count = 0;
rh_count = 0; rv_count = 0; rt_count = 0;
which_lh_col = []; which_lv_col = []; which_lt_col = [];
which_rh_col = []; which_rv_col = []; which_rt_col = [];

%if ~exist( 'r_files_loaded' ) r_files_loaded = 0; end
%if ~exist( 'a_files_loaded' ) a_files_loaded = 0; end
%if ~exist( 'o_files_loaded' ) o_files_loaded = 0; end
%total_files_loaded = r_files_loaded + a_files_loaded + o_files_loaded;
[total_files_loaded, dummy] = size(namearray);
if total_files_loaded == 0
   disp( 'There is no data.  Use RD to load files' );
   break
end

%initialize hBox
for x = 1:total_files_loaded
   hBox(x,1) = 0; hBox(x,2) = 0; hBox(x,3) = 0;
   hBox(x,4) = 0; hBox(x,5) = 0; hBox(x,6) = 0;
end

offset(1) = 0;
offset(2) = 280;
offset(3) = 560;

% each file gets a 20 pixel high row of buttons.  Then add
% 20 pixels for labels at top, 20 pixels for 'OK' & 'CANCEL'
% 20 pixels for each "Any files/Files w/saccades" radio button
% and 5 pixels for bottom border.
if total_files_loaded <= 15
   filesInCol(1) = total_files_loaded;
   numCols = 1;
 elseif total_files_loaded <=30
   filesInCol(1) = ceil(total_files_loaded/2);
   filesInCol(2) = total_files_loaded - filesInCol(1);
   numCols = 2;
 elseif total_files_loaded <=45
   filesInCol(1) = ceil(total_files_loaded/3);
   filesInCol(2) = filesInCol(1);
   filesInCol(3) = total_files_loaded - 2*filesInCol(1);
   numCols = 3;
end

% make the window
fig_height = (20 * filesInCol(1)) + 110;
startXPos = (640 - numCols*180)/2;
startYPos = (480 - fig_height)/2;
prepfig = figure('pos',[startXPos, startYPos, 280*numCols, fig_height],...
         'Resize', 'off', 'Name', 'Pick yer data',...
         'NumberTitle', 'off');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
set( prepfig, 'KeyPressFcn', 'pdkey( get(gcf,''CurrentCharacter'') )' );

% do the labels at the top of each column
for i = 1:numCols
   uicontrol(prepfig, 'Style', 'text',...
            'Pos', [ 5+(offset(i)) fig_height-20 15 15 ],...
            'String', 'lh');
   uicontrol(prepfig, 'Style', 'text',...
            'Pos', [ 30+(offset(i)) fig_height-20 15 15 ],...
            'String', 'rh');
   uicontrol(prepfig, 'Style', 'text',...
            'Pos', [ 55+(offset(i)) fig_height-20 15 15 ],...
            'String', 'lv');
   uicontrol(prepfig, 'Style', 'text',...
            'Pos', [ 80+(offset(i)) fig_height-20 15 15 ],...
            'String', 'rv');
   uicontrol(prepfig, 'Style', 'text',...
            'Pos', [ 105+(offset(i)) fig_height-20 15 15 ],...
            'String', 'lt');
   uicontrol(prepfig, 'Style', 'text',...
            'Pos', [ 130+(offset(i)) fig_height-20 15 15 ],...
            'String', 'rt');
   uicontrol(prepfig, 'Style', 'text',...
            'Pos', [ 155+(offset(i)) fig_height-20 120 15 ],...
            'String', 'file:  (w-form, sac-type)');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% loop to make the check boxes and labels

% first initialize the which_xx_col arrays
for i = 1:total_files_loaded
   which_lh_col(i) = 0; which_lv_col(i) = 0; which_lt_col(i) = 0; 
   which_rh_col(i) = 0; which_rv_col(i) = 0; which_rt_col(i) = 0; 
end

% set up radio buttons
uicontrol( 'Style', 'frame', 'Units', 'pixels',...
           'Position', [2 27 159 40]);

allFiles = 1;
hSacRB(1) = uicontrol( 'Style','radio','Units','pixels',...
          'Position',[5 50 155 16],...
          'String','Show <A>ll files/channels',...
          'Value', allFiles, 'Callback',...
           ['sacsel(hBox, hSacRB, 1, total_files_loaded, hasSacPts)'] );

hSacRB(2) = uicontrol( 'Style','radio','Units','pixels',...
          'Position',[5 30 155 16],...
          'String','Show w/<S>accade data.',...
          'Value', abs(allFiles-1), 'Callback',...
           ['sacsel(hBox, hSacRB, 2, total_files_loaded, hasSacPts)'] );

filenum = 0;
for i = 1:numCols
   for j = 1:filesInCol(i)
      filenum = filenum + 1;
      y_pos = (fig_height - 20) - j*20;
      % left eye, horizontal
      if has_LH(filenum) == 1
         lh_count = lh_count + 1;
         which_lh_col(filenum) = lh_count;
         if (hasSacPts(filenum,1) == 1) | allFiles
            flag1 = 'on'; flag2 = 1;
          else
            flag1 = 'off'; flag2 = 0;
         end
         hBox(filenum,1) = uicontrol('Style','CheckBox','Units','pixels',...
           'ForeGroundColor','black',...
           'Position',[5+offset(i) y_pos 15 15], 'Value', flag2,...
           'Enable', flag1);
      end
      % right eye, horizontal
      if has_RH(filenum) == 1
         rh_count = rh_count + 1;      
         which_rh_col(filenum) = rh_count;
         if (hasSacPts(filenum,2) == 1) | allFiles
            flag1 = 'on'; flag2 = 1;
          else
            flag1 = 'off'; flag2 = 0;
         end
         hBox(filenum,2) = uicontrol('Style','CheckBox','Units','pixels',...
           'ForeGroundColor','black',...
           'Position',[30+offset(i) y_pos 15 15], 'Value', flag2,...
           'Enable', flag1);
      end
      % left eye, vertical
      if has_LV(filenum) == 1
         lv_count = lv_count + 1;
         which_lv_col(filenum) = lv_count;
         if (hasSacPts(filenum,3) == 1) | allFiles
            flag1 = 'on'; flag2 = 1;
          else
            flag1 = 'off'; flag2 = 0;
         end
         hBox(filenum,3) = uicontrol('Style','CheckBox','Units','pixels',...
           'ForeGroundColor','black',...
           'Position',[55+offset(i) y_pos 15 15], 'Value', flag2,...
           'Enable', flag1);
      end
      % right eye, vertical
      if has_RV(filenum) == 1
         rv_count = rv_count + 1;      
         which_rv_col(filenum) = rv_count;
         if (hasSacPts(filenum,4) == 1) | allFiles
            flag1 = 'on'; flag2 = 1;
          else
            flag1 = 'off'; flag2 = 0;
         end
         hBox(filenum,4) = uicontrol('Style','CheckBox','Units','pixels',...
           'ForeGroundColor','black',...
           'Position',[80+offset(i) y_pos 15 15], 'Value', flag2,...
           'Enable', flag1);
      end
      % left eye, torsional
      if has_LT(filenum) == 1
         lt_count = lt_count + 1;
         which_lt_col(filenum) = lt_count;
         if (hasSacPts(filenum,5) == 1) | allFiles
            flag1 = 'on'; flag2 = 1;
          else
            flag1 = 'off'; flag2 = 0;
         end
         hBox(filenum,5) = uicontrol('Style','CheckBox','Units','pixels',...
           'ForeGroundColor','black',...
           'Position',[105+offset(i) y_pos 15 15], 'Value', flag2,...
           'Enable', flag1);
      end
      % right eye, torsional
      if has_RT(filenum) == 1
         rt_count = rt_count + 1;      
         which_rt_col(filenum) = rh_count;
         if (hasSacPts(filenum,6) == 1) | allFiles
            flag1 = 'on'; flag2 = 1;
          else
            flag1 = 'off'; flag2 = 0;
         end
         hBox(filenum,6) = uicontrol('Style','CheckBox','Units','pixels',...
           'ForeGroundColor','black',...
           'Position',[130+offset(i) y_pos 15 15], 'Value', flag2,...
           'Enable', flag1);
      end

      % create the filename label
      fileStr = deblank(namearray(filenum,:));
      [wfStr,stStr] = strtok(whichWFST(filenum,:));
      wfStr = deblank(wfStr);
      stStr = strtok(stStr);
      dispStr = [fileStr ' (' wfStr ', ' stStr(1) ')'];
      uicontrol(prepfig, 'Style', 'text',...
          'Pos', [ 155+offset(i) y_pos 120 15 ],...
          'String', dispStr);

   end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% make the buttons
% toggles will turn off all the checked boxes for their column
hLHToggle = uicontrol( 'Style','Pushbutton','Units','pixels',...
          'Position',[1 70 24 15], 'String','Off',...
          'Callback', ['toggle(hLHToggle, hBox, 1, total_files_loaded)'] );

hRHToggle = uicontrol( 'Style','Pushbutton','Units','pixels',...
          'Position',[26 70 24 15], 'String','Off',...
          'Callback', ['toggle(hRHToggle, hBox, 2, total_files_loaded)'] );

hLVToggle = uicontrol( 'Style','Pushbutton','Units','pixels',...
          'Position',[51 70 24 15], 'String','Off',...
          'Callback', ['toggle(hLVToggle, hBox, 3, total_files_loaded)'] );

hRVToggle = uicontrol( 'Style','Pushbutton','Units','pixels',...
          'Position',[76 70 24 15], 'String','Off',...
          'Callback', ['toggle(hRVToggle, hBox, 4, total_files_loaded)'] );

hLTToggle = uicontrol( 'Style','Pushbutton','Units','pixels',...
          'Position',[101 70 24 15], 'String','Off',...
          'Callback', ['toggle(hLTToggle, hBox, 5, total_files_loaded)'] );

hRTToggle = uicontrol( 'Style','Pushbutton','Units','pixels',...
          'Position',[126 70 24 15], 'String','Off',...
          'Callback', ['toggle(hRTToggle, hBox, 6, total_files_loaded)'] );

% 'OK' will accept the check boxes.
uicontrol( 'Style','Pushbutton','Units','pixels',...
    'Position',[5 5 50 15], 'String','OK',...
    'Callback', ['readBox; pdclear;']);

% 'Cancel' will abort the selection process.
uicontrol( 'Style','Pushbutton','Units','pixels',...
    'Position',[60 5 50 15], 'String','Cancel',...
    'Callback', ['close(prepfig); pdclear;']);
       
hMakeVel  = uicontrol( 'Style','CheckBox','Units','pixels',...
          'Position',[165 50 110 16],...
          'String','Make vel. array.',...
          'Value', 1, 'Callback',[''] );

hMakeAcc  = uicontrol( 'Style','CheckBox','Units','pixels',...
          'Position',[165 30 110 16],...
          'String','Make accel. array.',...
          'Value', 0, 'Callback',[''] );
       
hMakeTime = uicontrol( 'Style','CheckBox','Units','pixels',...
          'Position',[165 10 110 16],...
          'String','Make time array.',...
          'Value', 1, 'Callback',[''] );
