% rd_bin.m:    called by RD to handle .bin data files that have
%              NO header information

% written by:  Jonathan Jacobs
%              March 1997 - February 2004 (last mod: 02/25/04)

% 01/30/03: added line "clear newdata" to guarantee ability to load
%           multiple datasets

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% open the bin file
if comp(1) == 'M'
   fidBIN = fopen( [pathname filename], 'r', 'l');
 else
   fidBIN = fopen( [pathname filename], 'r' );
end

% this is not useful anymore. consider yourself deprecated, filecounter!
b_files = b_files + 1;
total_files = r_files + a_files + b_files...
                   + o_files + x_files + l_files;

% read in the data
fseek(fidBIN, 0, 'bof');
[tempdata, numsamps] = fread(fidBIN,inf,'float32');

% Get number of channels and samples when bias info is loaded
% use the info to separate the raw binary stream into calibrated channels
getbias
dat_len = numsamps/chan_count;
disp( ['  Sampling frequency: ' num2str(tempSampFreq)] );
disp( ['  Duration of record: ' num2str(dat_len/tempSampFreq)] );

fclose(fidBIN); clear fidBIN

% Is the data stored contiguously or is it interleaved
% c: {ch1samp1...ch1sampN, ch2samp1...ch2sampN, ... , chMsamp1...chMsampN}
% i: {ch1samp1 ch2samp1...chMsampN, ... , ch1sampN ch2sampN...chMsampN}
clear newdata
if organization(1) == 'u'
   % do something clever here to let the user see  the results of
   % each options and choose which one is better?
end
   
if organization(1) == 'c'
	% data stored as contiguous blocks
	for i = 1:chan_count
	   newdata(:,i) = tempdata( (i-1)*dat_len+1: dat_len*i);
	end
 elseif organization(1) == 'i'
	% data stored interleaved
	for i = 1:chan_count
	   ind = (0:dat_len-1)*chan_count + i;
	   newdata(:,i) = tempdata(ind);
	end
end  

% apply the offset and scaling factors
applybias

[dat_len, dat_cols] = size( newdata );
disp( ['  Channels found:     ' num2str(dat_cols)] );
disp( ['  Samples found:      ' num2str(dat_len)] );


clear fidBIN i commStrLen chan_count dat_len temp count
clear tempdata numsamps commOffset