% readhdrm.m:  reads the header information from 
% 'RETRIEVE' format files.  This is the Mac version.
% written by: Jonathan Jacobs, based on code by Vallabh Das
%             July 1995 - March 1995  (last mod: 03/26/95)

this_entry = a_files + r_files +1;

disp( 'Reading RTRV header...' )
vers = fread(fid,1,'float32');
imon = fread(fid,1,'int8');

fseek(fid,3,'cof');
iday = fread(fid,1,'int8');

fseek(fid,3,'cof');
iyear = fread(fid,1,'short');

fseek(fid,2,'cof');
ihour = fread(fid,1,'int8');

fseek(fid,3,'cof');
imin = fread(fid,1,'int8');

fseek(fid,3,'cof');
temp = fread(fid,64,'uchar');
subj_name(this_entry,1:64) = [setstr(temp)]';
temp = fread(fid,64,'uchar');
comments(this_entry,1:64) = [setstr(temp)]';
art_array = fread(fid,20,'uchar');
art_array = [setstr(art_array)]';
ad_bits = fread(fid,1,'int8');

fseek(fid,3,'cof');
ad_gain = fread(fid,1,'int8');

fseek(fid,3,'cof');
degmax = fread(fid,1,'float32');

if vers > 1.02                 % skip to # of channels
   degmax2 = fread(fid,1,'float32');
   degmax3 = fread(fid,1,'float32');
   %fseek(fid,8,'cof');
end

channels(this_entry) = fread(fid,1,'int8');

fseek(fid,3,'cof');
start_ch = fread(fid,1,'int8');

fseek(fid,3,'cof');
tempSampFreq = fread(fid,1,'float32');
%if channels(length(channels)) == 8
%   ch = 8;
% elseif channels(length(channels)) == 3
%   ch = 3;
% elseif channels(length(channels)) == 4
%   ch = 4;
% elseif channels(length(channels)) == 2
%   ch = 2;
% elseif channels(length(channels)) == 1
%   ch = 1;
%end

ch = channels(length(channels));

arr_len = fread(fid,1,'short');

fseek(fid,2,'cof');
idate(this_entry,:) = (str2mat(imon,iday,iyear))';
itime(this_entry,:) = (str2mat(ihour,imin))';

if vers > 1.02                 % skip to the data
   fseek(fid,72,'cof');
end
