% sincorrect: correct data taken with the old Robinson coil system.
% Usage:
%       function out = sincorrect( in, offset, scale, calpt )
% Example:
%       rh = sincorrect(rh,+/-offset,20.34,20);

% written by:  Jonathan Jacobs
%              October 1999  (last mod:  10/11/99)


function out = sincorrect( in, offset, scale, calpt )

[r,c]=size(in);

% make sure it's column oriented
if c>r, in = in';end

if isinf(scale)
   disp('***Scale value not yet selected - only bias shift will be applied***')
   out(:,c) = in(:,c)-offset;
   return
end

calptrad=(calpt*pi/180);
temp = asin( (in(:,c)-offset)/(scale/calptrad) )*180/pi;

out(:,c) = temp;
