% text2bin.m: convert an .txt file to a raw binary format ('.bin') file

% Written by:  Jonathan Jacobs
%              February 2004 (last mod: 02/26/04)


function txt2bin(null)

curdir = pwd;

[fn, pn]=uigetfile('*.txt', 'Select a file to load');

if fn == 0, disp('Aborted.'); return, end

eval(['load ' ['''' pn fn '''']])

fname = strtok(fn,'.');
eval(['in = ' fname ';']);

[r,c]=size(in); if c>r, in=in'; end

disp(['I believe that there are ' num2str(min(r,c)) ' channels,'])
disp(['and there are ' num2str(max(r,c)) ' samples per channel.'])
yorn = input('Do you agree (y/n)? ','s');

switch(yorn)
 case{'n','no'}
   disp('Aborting.  No conversion performed.')
   return
 case {'y','yes'}
	cfile = [fname '.bin'];
	eval(['cd ' '''' pn ''''])
	disp(['saving ' '''' pn cfile ''''])
	fid = fopen(cfile, 'w', 'l');
	fwrite(fid, in, 'float');
	fclose(fid);
   disp(['Converted file ' cfile ' written to ' pn])
end  

exten   = '.bin' ;
ftype   = '    ' ;
creator = 'dosa' ;

comp=computer;
if strcmp(comp,'MAC2') & exist('filetype.m') == 2 & exist('filetype.mex') == 3
   disp('Changing filetype and creator.')
   [oldtype,oldcreator]=filetype(cfile, ftype, creator);
end

cd(curdir)
