% swap_em.m:  called by movedata to swap file row/cols.
% written by: Jonathan Jacobs
%             May 1996

function [out] = zap_em(in, source, numFiles, orientation )

[inR, inC] = size(in);

% when info is organized along columns
% this includes a one-row vector  (i.e. 1 x n)
if( strcmp(orientation, 'col') )
   out = [in(:, 1:source-1), in(:, source+1:numFiles)];
end   

% when info is organized along rows
% this includes a one-column vector  (i.e. n x 1)
if strcmp( orientation, 'row' )
   out = [in(1:source-1,:); in(source+1:numFiles,:)];
end