% efit.m: Nonlinear curve fit with simplex algorithm.
% uses 'efitfun.m' to do the real work.
% usage: efit(xdata,ydata);

% Written by:  Jonathan Jacobs
%              June 1998 - December 2001 (last mod: 12/14/01)

function [null]=efit(xdata,ydata);

global xdata ydata plotH c

% precision of num2str for display
prec = 10;
getnewdata = 0;
fdstr='';

order = input('What order fit? ');

figure
hold on
%axis([min(xdata) max(xdata) min(ydata) max(ydata)])
plot(xdata,ydata,'co')
plotH = plot(xdata,ydata);

% make sure data is row-oriented 
[rows,cols]=size(xdata);
if cols == 1, xdata=xdata';end						
[rows,cols]=size(ydata);
if cols == 1, ydata=ydata';end						

% do the actual work here...
% ('efitfun' is a Mathworks file that I have ruthlessly
% appropriated for use here; it is called by 'fminsearch')
lam = [1 zeros(order-1,1)']'; 
trace = 0;
tol = 0.001;
lambda = fminsearch('eFitFun',lam,[trace tol]);

% regenerate the fit line for use in calculating statistics
recon=0;
for i = 1:length(lambda);
   recon =  recon + c(i)*exp(-lambda(i)*xdata);
end

rsq = rsqr(ydata,recon);
title(['r^2 value: ' num2str(rsq)])

% print out the final results
disp('Paste these values into your "PHexpf.m" type function:')
for i = 1:length(lambda)
   disp(['c(' num2str(i) ')=' num2str(c(i),prec) ';']);
end
disp(' ')
for i = 1:length(lambda)
   disp(['lambda(' num2str(i) ')=' num2str(lambda(i),prec) ';']);
end

disp(' ')
disp(['r^2 = ' num2str(rsq)]);
