% notch.m:  notch filter.
% Usage: output = notch(input, filter order, low edge, high edge, samp freq);

% Written by:  Jonathan Jacobs
%              May 1997 - January 2004 (last mod: 01/10/04)

% guess what? either 'butter' or 'filtfilt' can't handle NaNs!
% wankers.  Temporarily replace those nasty NaNs with honest zeros.
% then swap the NaNs back after the filtering's done.

function out = notch(in, ord, lo, hi, sampf)

if nargin < 5
   help notch
   return
end

nanPts = isnan(in);
in = bridgenan(in);

nyqf = sampf/2;
[b,a] = butter(ord, [lo/nyqf hi/nyqf], 'stop');

out = filtfilt(b,a,in);
out(nanPts) = NaN;