% obrView.m: Takes raw Ober data and transforms/plots it into
% data that is approximately in degrees with an approximate zero.
%
% USAGE: obrView
% To view/plot Ober data after reading it in with RD

% Written by:  L.F. Dell'Osso
%              May 2000  (last mod: 05/16/00)


function obrView

global rh lh rv lv namelist
figure; hold on

if exist('rh',1)
   t=maket(rh);
   rhrc = (rh-2048)*0.03;
   assignin('base','rhrc',rhrc);
   plot(t,rhrc,'c')
   maxpt=max(rhrc);
   minpt=min(rhrc);
   maxt=max(t);
   rehH=text(maxt,maxpt,'RHRC');
   set(rehH,'color','c');
end

if exist('lh',1)
   t=maket(lh);
   lhrc = (lh-2000)*0.03;
   assignin('base','lhrc',lhrc);
   plot(t,lhrc,'y--')
   maxpt=max(lhrc);
   minpt=min(lhrc);
   maxt=max(t);
   lehH=text(maxt,minpt,'LHRC');
   set(lehH,'color','y');
end

if exist('rv',1)
   t=maket(rv);
   rvrc = (rv-2000)*0.03;
   assignin('base','rvrc',rvrc);
   plot(t,rvrc,'r')
   maxpt=max(rvrc);
   minpt=min(rvrc);
   maxt=max(t);
   revV=text(maxt,maxpt,'RVRC');
   set(revV,'color','r');
end

if exist('lv',1)
   t=maket(lv);
   lvrc = (lv-2000)*0.03;
   assignin('base','lvrc',lvrc);
   plot(t,lvrc,'g--')
   maxpt=max(lvrc);
   minpt=min(lvrc);
   maxt=max(t);
   levV=text(maxt,maxpt,'LVRC');
   set(levV,'color','g');
end

title(namelist)
ept
dragger

 


