% randgen.m:  generate a uniformly distributed set of random numbers...
% ...and don't pick the same value twice in a row, ok?

% written by:  Jonathan Jacobs
%              March 1999  (last mod: 03/11/99)

function  out = randgen(in)

stimlist = [-20 -15 -10 -5 0 5 10 15 20];

if nargin < 1
   numperpos = input('How many fixations at each position? ');
 else
   numperpos = in;
end

fixesleft = numperpos*ones(length(stimlist),1);

numfixes = numperpos * length(stimlist);

count = 1;
lastind = 0;
while count <= numfixes

   ind = fix(rand*10);
   if ind > 0
      if fixesleft(ind) & ind~=lastind
         fixesleft(ind) = fixesleft(ind)-1;
         out(count) = stimlist(ind);
         count = count + 1;
         lastind=ind;
      end
   end
end
