% saccgen.m: A primitive CLI program to generate the saccade stimuli for
% the BME undergrad lab.  This stim file is meant to be read by the LabVIEW
% data acquisition/analog output VI.
% The sampling frequency is 100 Hz, a value that was set by acq_disp_AO.vi
% therefore times can be specified only within 0.01 seconds.
% Usage: out = saccgen;  (use of an output variable is optional)

% Written by:  Jonathan Jacobs
%              March 1999 (last mod: 03/12/99)

function out = saccgen(null);

samptemp = 100;
ampl = 15;

initialpath = pwd;

t_or_s = 't';
tstr = 'seconds';
sampf = samptemp;

promptstr = 'How many cycles? ';
numcyc=-1;
while (numcyc<= 0)
   numcyc = input(promptstr);
end

promptstr = 'What frequency? ';
cycfreq=-1;
while (cycfreq<= 0)
   cycfreq = input(promptstr);
end

tvect = 0.01:0.01:(numcyc/cycfreq);

amplvect = ampl*sin(2*pi*tvect*cycfreq)';

%size(amplvect)

disp(['This trial will take ' num2str(numcyc/cycfreq) ' seconds'])

figure
t=maket(amplvect,sampf);
plot(t,amplvect)
xlabel(['Time (' tstr ')'])
ylabel('Stimulus Amplitude (deg)')
title('STIMGEN output')

disp(' ')
%disp('If you are happy with this result, you can save it as an ASCII file')
%disp('Otherwise, run "STIMGEN" again.')
yorn=lower(input('Write this to file (y/n)? ','s'));

file = 0;
if yorn=='y'
   [file, path] = uiputfile('*.stm', 'Save As');
end

if file == 0
   %disp('No file written.')
   %eval(['cd ' '''' initialpath ''''])
 else
	eval(['cd ' '''' path ''''])
	eval(['save ' file ' amplvect  -ascii'])
   disp(['"' file '" written to "' path '"'])

   % if 'filetype.m' and 'filetype.mex' are present we will use 'em
   if strcmp(comp,'MAC2') & exist('filetype.m') == 2 & exist('filetype.mex') == 3
      [oldtype,oldcreator]=filetype('adjbias.txt','TEXT','R*ch');
   end

	%eval(['cd ' '''' initialpath ''''])
end


if nargout == 0
   return
 else
   out = amplvect;
end
