% stretch.m: world's simplest interpolation: just repeats each
% point n times. Useful for making sample rates agree when overplotting
% data by their index on the same axis.
% Usage: out=stretch(in, n) will take array "in" and duplicate each point
%        in it n times.

function out = stretch(in, n)

[r,c]=size(in);

if r>1 & c>1
   disp('"stretch" only works for 1-D arrays right now.')
   break
end

% organize as row-oriented
if r>1
   in = in';
   [r,c]=size(in);
end   

out = zeros(1,n*c);

for i = 1:n
   
   out(i: n: n*c) = in;
   
end
