% sub2.m: Take a subsection of an array.
% Usage: subArray = sub(array, startTime, duration);
% See also: SUBP, TPLOT

% Written by:  Jonathan Jacobs
%              February 1997 - March 1997  (last mod: 03/02/97)

function subArray = sub(inArray, startTime, stopTime)
global samp_freq

if isempty(samp_freq)
   samp_freq = input('Enter the sampling frequency: ');
end

if nargin == 0
   help sub
   return
end

[numDRows,numDCols] = size( inArray );
if (numDRows < numDCols)
   inArray = inArray';
   [numDRows,numDCols] = size( inArray );
end

startPt = fix(startTime*samp_freq);
if startPt == 0, startPt = 1; end
stopPt = fix(stopTime*samp_freq);
if stopPt > numDRows, stopPt = numDRows; end

subArray = inArray(startPt:stopPt);
