% tconvert.m:  convert between time and sample number.
% usage: 'tconvert(t1, t2);', where t1 and t2 are both times or samples.
  
% Written by: Jonathan Jacobs
%             February 1997  (last mod: 02/25/97)

function [outVect] = range(in1, in2)

global samp_freq

if nargin == 0
   help tconvert
   %disp('usage: range(t1, t2);')
   return
end

if (samp_freq == 0) | isempty(samp_freq)
   samp_freq = input('Enter the sampling frequency: ');
end

if (in1 < 100) & (in2 < 100)     % assume it's time
   out1 = round(in1*samp_freq);
   out2 = round(in2*samp_freq);
   if out1 == 0, out1=1;end
   if out2 == 0, out2=1;end
   inStr  = 'sec';
   outStr = 'samp';
 else                            % assume it's a sample
   out1 = in1/samp_freq;
   out2 = in2/samp_freq;
   if out1 == 0, out1=1/samp_freq;end  % these lines should never
   if out2 == 0, out2=1/samp_freq;end  % actually execute...
   inStr  = 'samp';
   outStr = 'sec';
end

disp([inStr ' --> ' outStr])
disp(['(' num2str(in1)  ', ' num2str(in2) ') --> '... 
      '(' num2str(out1) ', ' num2str(out2) ')' ])

%outVect = [out1 out2];
